Summary: The GNU Scientific Library for numerical analysis
Name: carta-gsl
Version: 2.5
Release: 2%{?dist}
URL: http://www.gnu.org/software/gsl/
# info part of this package is under GFDL license
# eigen/nonsymmv.c and eigen/schur.c
# contains rutiens which are part of LAPACK - under BSD style license
License: GPLv3 and GFDL and BSD
Group: System Environment/Libraries

%define _unpackaged_files_terminate_build 0
Prefix: /opt/carta-gsl

Source: ftp://ftp.gnu.org/gnu/gsl/%{name}-%{version}.tar.gz
Patch0: gsl-1.10-lib64.patch
# http://lists.gnu.org/archive/html/bug-gsl/2015-12/msg00012.html
Patch1: gsl-tol.patch
Patch2: gsl-test.patch
BuildRequires: pkgconfig

%description
The GNU Scientific Library (GSL) is a collection of routines for
numerical analysis, written in C.

%package devel
Summary: Libraries and the header files for GSL development
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires(post): /sbin/install-info
Requires(preun): /sbin/install-info 
Requires: pkgconfig, automake

%description devel
The gsl-devel package contains the header files necessary for 
developing programs using the GSL (GNU Scientific Library).

%prep
%setup -q
%patch0 -p1 -b .lib64
%patch1 -p1 -b .tol
%patch2 -p1 -b .test

iconv -f windows-1252 -t utf-8 THANKS  > THANKS.aux
touch -r THANKS THANKS.aux
mv THANKS.aux THANKS

%build
# disable FMA
%ifarch aarch64 ppc64 ppc64le s390 s390x
export CFLAGS="$RPM_OPT_FLAGS -ffp-contract=off"
%endif
#%configure 
./configure --prefix=/opt/carta-gsl --includedir=/opt/carta-gsl/include --libdir=/opt/carta-gsl/lib --mandir=/opt/carta-gsl/share/man
make %{?_smp_mflags}

%check
make check || ( cat */test-suite.log && exit 1 )

%install
make install DESTDIR=$RPM_BUILD_ROOT install='install -p'
# remove unpackaged files from the buildroot
#rm -rf $RPM_BUILD_ROOT%{_infodir}/dir
#rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
# remove static libraries
#rm -r $RPM_BUILD_ROOT%{_libdir}/*.a

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post devel
if [ -f %{_infodir}/gsl-ref.info.gz ]; then
    /sbin/install-info %{_infodir}/gsl-ref.info %{_infodir}/dir || :
fi

%preun devel
if [ "$1" = 0 ]; then
    if [ -f %{_infodir}/gsl-ref.info.gz ]; then
	/sbin/install-info --delete %{_infodir}/gsl-ref.info %{_infodir}/dir || :
    fi
fi

%files
/opt/carta-gsl/lib/libgsl.so.23*
/opt/carta-gsl/lib/libgslcblas.so.0*
/opt/carta-gsl/lib/pkgconfig/gsl.pc
/opt/carta-gsl/bin/*
%exclude /opt/carta-gsl/share/*
%exclude /opt/carta-gsl/lib/libgsl.a
%exclude /opt/carta-gsl/lib/libgsl.la
%exclude /opt/carta-gsl/lib/libgslcblas.a
%exclude /opt/carta-gsl/lib/libgslcblas.la

%files devel
/opt/carta-gsl/include/*
/opt/carta-gsl/lib/*.so

%changelog
* Mon Mar 21 2022 Anthony Moraghan <ajm@asiaa.sinica.edu.tw> 2.5
- gsl 2.5 for carta-backend based on the el8 version with custom install location at /opt/carta-gsl
  so as not to interfere with default gsl 1.15 on el7.
